package org.seasar.javelin.jmx;

import java.lang.management.ManagementFactory;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import javax.management.MBeanServer;
import javax.management.ObjectName;

import mx4j.tools.adaptor.http.HttpAdaptor;
import mx4j.tools.adaptor.http.XSLTProcessor;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;
import org.seasar.javelin.jmx.bean.Component;
import org.seasar.javelin.jmx.bean.ComponentMBean;
import org.seasar.javelin.jmx.bean.Container;
import org.seasar.javelin.jmx.bean.ContainerMBean;
import org.seasar.javelin.jmx.bean.Invocation;
import org.seasar.javelin.jmx.bean.InvocationMBean;

/**
 * ComponentԂ̌Ăяo֌WMBeanƂČJ邽߂InterceptorB
 * ȉ̏AMBeanoRŎ擾邱Ƃ\B
 * <ol>
 * <li>\bȟĂяo</li>
 * <li>\bh̕Ϗԁi~bPʁj</li>
 * <li>\bh̍Œԁi~bPʁj</li>
 * <li>\bh̍ŒZԁi~bPʁj</li>
 * <li>\bȟĂяo</li>
 * <li>O̔</li>
 * <li>O̔</li>
 * </ol>
 * ܂Aȉ̏dicont@Cł̃p[^Ŏw\B
 * <ol>
 * <li>httpPort:HTTPŌJۂ̃|[gԍBgpɂMX4JKvB</li>
 * <li>intervalMax:\bh̏Ԃ񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>throwableMax:O̔񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>recordThreshold:ԋL^p臒lB
 *     ̎Ԃz\bhĂяô݋L^B
 *     ftHgl0B</li>
 * <li>domain:MBeano^ۂɎgphCB
 *     ۂ̃hĆA[domainp[^] + [Mbean̎]ƂȂB
 *     MBean̎ނ͈ȉ̂̂B
 *     <ol>
 *       <li>container:SR|[lgObjectNameǗB</li>
 *       <li>component:̃R|[lgɊւJMBeanB</li>
 *       <li>invocation:\bhĂяoɊւJMBeanB</li>
 *     </ol>
 *     </li>
 * </ol>
 * 
 * @version 0.1
 * @author Masanori Yamasaki(SMG)
 */
public class S2JmxJavelinInterceptor extends AbstractInterceptor
{
    private static final long serialVersionUID = 6661781313519708185L;

    private static MBeanServer server_;

    /** ComponentMBeano^}bvB */
    private static Map mBeanMap_;

    /** tOBς݂̏ꍇtrueB */
    private static boolean isInitialized_ = false;
    
    /** ĂяoL^ő匏BftHgl1000B */
    private int intervalMax_  = 1000;

    /** O̔L^ő匏BftHgl1000B */
    private int throwableMax_ = 1000;

    /** 
     *  ĂяoL^ۂ臒lB
     *  li~bj鏈Ԃ̌Ăяo͋L^ȂB
     *  ftHgl0B 
     */
    private long recordThreshold_ = 0;

    /**
     * JHTTP|[gԍBiMX4JKvBj
     */
    private int httpPort_ = 0;
    
    /**
     * hCB
     * ftHgl"org.seasar.javelin.jmx.default"B
     */
    private String domain_ = "org.seasar.javelin.jmx.default";
    
    /**
     * \bȟĂяoIuWFNgB
     */
    private ThreadLocal caller_ = new ThreadLocal()
    {
        protected synchronized Object initialValue()
        {
            return null;
        }
    };

    /**
     * B
     * MBeanServerւContainerMBean̓o^sB
     * JpHTTP|[gw肳Ăꍇ́AHttpAdaptor̐Ɠo^sB
     */
    private void init()
    {
    	try
    	{
    		server_ = ManagementFactory.getPlatformMBeanServer();

    		mBeanMap_ = new HashMap();
    		
    		if (httpPort_ != 0)
    		{
        	    XSLTProcessor processor = new XSLTProcessor();
        	    ObjectName processorName = 
        	    	new ObjectName("Server:name=XSLTProcessor");
                if (server_.isRegistered(processorName))
                {
                	Set beanSet = server_.queryMBeans(processorName, null);
                	if (beanSet.size() > 0)
                	{
                		XSLTProcessor[] processors =
                			(XSLTProcessor[])beanSet.toArray(
                			    new XSLTProcessor[beanSet.size()]);
                		processor = (XSLTProcessor)(processors[0]);
                	}
                }
                else
                {
            	    server_.registerMBean(processor, processorName);
                }
        	    
                HttpAdaptor adaptor;
        		ObjectName adaptorName = 
        			new ObjectName("Adaptor:name=adaptor,port=" + httpPort_);
                if (server_.isRegistered(adaptorName))
                {
                	Set beanSet = server_.queryMBeans(adaptorName, null);
                	if (beanSet.size() > 0)
                	{
                		HttpAdaptor[] adaptors =
                			(HttpAdaptor[])beanSet.toArray(
                			    new HttpAdaptor[beanSet.size()]);
                		adaptor = (HttpAdaptor)(adaptors[0]);
                	}
                }
                else
                {
                    adaptor = new HttpAdaptor();
                    adaptor.setProcessor(processor);
                    adaptor.setPort(httpPort_);
                    server_.registerMBean(adaptor, adaptorName);
                    adaptor.start();
                }
                
    		}

            ContainerMBean container;
    		ObjectName containerName = new ObjectName(
    				domain_ 
    				+ ".container:type=" 
    				+ ContainerMBean.class.getName());        
            if (server_.isRegistered(containerName))
            {
            	Set beanSet = server_.queryMBeans(containerName, null);
            	if (beanSet.size() > 0)
            	{
            		ContainerMBean[] containers =
            			(ContainerMBean[])beanSet.toArray(
            			    new ContainerMBean[beanSet.size()]);
            		container = (ContainerMBean)(containers[0]);
            	}
            }
            else
            {
                container = new Container(mBeanMap_);
                server_.registerMBean(container, containerName);
            }
        }
    	catch(Exception ex)
    	{
    		ex.printStackTrace();
    	}
    }
    
    /**
     * Ăяo擾pinvoke\bhB
     * 
     * ۂ̃\bhĂяosOŁA
     * s񐔂sԂMBeanɋL^B
     * 
     * sɗOꍇ́A
     * O̔񐔂┭L^B
     * 
     * @param invocation
     *            C^[Zv^ɂĎ擾ꂽAĂяo\bh̏
     * @return invocationsƂ̖߂l
     * @throws Throwable invocationsƂɔO
     */
    public Object invoke(MethodInvocation invocation) throws Throwable
    {
    	synchronized (this.getClass())
		{
    		if (!isInitialized_)
    		{
    			isInitialized_ = true;
    			init();
    		}
		}
    	
        // Ăяo擾B
        String calleeClassName  = getTargetClass(invocation).getName();
        String calleeMethodName = invocation.getMethod().getName();
        
        Component  componentBean = (Component)(mBeanMap_.get(calleeClassName));
    	String name = 
    		domain_ 
    		+ ".component:type=" 
    		+ ComponentMBean.class.getName() 
    		+ ",class="
    		+ calleeClassName;
        ObjectName componentName = new ObjectName(name);
        if (componentBean == null)
        {
        	componentBean = new Component(componentName, calleeClassName);

        	server_.registerMBean(componentBean, componentName);
        	mBeanMap_.put(calleeClassName, componentBean);
        }
        
        Invocation invocationBean = 
        	componentBean.getInvocation(calleeMethodName);
    	name = 
    		domain_ 
    		+ ".invocation:type="
    		+ InvocationMBean.class.getName()
    		+ ",class="
    		+ calleeClassName 
    		+ ",method="
    		+ calleeMethodName;
		ObjectName objName = new ObjectName(name);
        if (invocationBean == null)
        {
            
        	invocationBean = 
        		new Invocation(
        				objName
        				, componentName
        				, calleeClassName
        				, calleeMethodName
        				, intervalMax_
        				, throwableMax_);
        	
        	componentBean.addInvocation(invocationBean);
    		server_.registerMBean(invocationBean, objName);
        }

        // Ăяo擾B
        Invocation caller = (Invocation) caller_.get();

        Object ret = null;
        try
        {
            // ĂяoA
        	// 񃍃Oǒ͎ĂяoƂĎgp邽߂ɕۑB
            caller_.set(invocationBean);
            
        	long start = System.currentTimeMillis();
        	
            // \bhĂяoB
            ret = invocation.proceed();
            
            long spent = System.currentTimeMillis() - start;
            if (spent >= recordThreshold_)
            {
                invocationBean.addInterval(spent, caller);
            }
        }
        catch (Throwable cause)
        {
        	// OL^ĂB
        	invocationBean.addThrowable(cause);
        	
            //OX[AIB
            throw cause;
        }
        finally
        {
            //ĂяoĂB
            caller_.set(null);
        }
        
        return ret;
    }

    /**
     * 
     * @param intervalMax
     */
	public void setIntervalMax(int intervalMax)
	{
		this.intervalMax_ = intervalMax;
	}

	/**
	 * 
	 * @param throwableMax
	 */
	public void setThrowableMax(int throwableMax)
	{
		this.throwableMax_ = throwableMax;
	}

	/**
	 * 
	 * @param recordThreshold
	 */
	public void setRecordThreshold(int recordThreshold)
	{
		this.recordThreshold_ = recordThreshold;
	}

	/**
	 * 
	 * @param httpPort
	 */
	public void setHttpPort(int httpPort)
	{
		httpPort_ = httpPort;
	}

	/**
	 * 
	 * @param domain
	 */
	public void setDomain(String domain)
	{
		domain_ = domain;
	}
}